#include <stdlib.h>
#include <string.h>
#include <go32.h>
#include <sys/nearptr.h>
#include <conio.h>
#include <dos.h>
#define GRAPH 0x0013
#define TEXT 0x0003

typedef unsigned char byte;
byte *vga=(byte *)0xA0000;
byte *vir=(byte *)malloc(64000);
int av[2560];
typedef struct{
float x,y,z;
byte col;
float yvel;
float xvel;
}star;

byte blit[10][10]={
  0,  0,  0,  0,  0,  5,  0,  0,  0,  0,  
  0,  0,  0,  0,  5, 10,  5,  0,  0,  0,  
  0,  0,  0,  5, 10, 30, 10,  5,  0,  0,  
  0,  0,  5, 10, 30, 50, 30, 10,  5,  0,  
  0,  5, 10, 30, 50,100, 50, 30, 10,  5,  
  0,  5, 10, 30, 50,100, 50, 30, 10,  5,  
  0,  0,  5, 10, 30, 50, 30, 10,  5,  0,  
  0,  0,  0,  5, 10, 30, 10,  5,  0,  0,  
  0,  0,  0,  0,  5, 10,  5,  0,  0,  0,  
  0,  0,  0,  0,  0,  5,  0,  0,  0,  0

  };


star points[10000];

void plot(int x, int y, byte col, byte *where)
{
long offs=((y)<<8)+((y)<<6)+(x);
byte ncol;
if((x>0)&&(x<320)&&(y>0)&&(y<200))

for(int count=0;count<10;count++)
for(int counter=0;counter<10;counter++)
{
ncol=blit[count][counter]+where[offs+count+(counter*320)];
if(ncol>150)ncol=150;
where[offs+count+(counter*320)]=ncol;
}
}

void flip(void)
{
memcpy(vga,vir,64000);
}

void setmode(byte mode)
{
union REGS reg;
reg.x.ax=mode;
int86(0x10,&reg,&reg);
}

void setpal(byte index, byte r, byte g, byte b)
{
outportb(0x3c7,index);
outportb(0x3c9,r);
outportb(0x3c9,g);
outportb(0x3c9,b);
}


void cls(byte col, byte *where)
{
memset(where,col,64000);
}

main(void)
{
int count;
__djgpp_nearptr_enable();
vga+=__djgpp_conventional_base;
setmode(GRAPH);
for(count=0;count<10000;count++)
{points[count].xvel=(float)(rand()%100-50)/50.0;points[count].yvel=(float)(rand()%200/75.0);points[count].x=rand()%120+100; points[count].y=160; points[count].col=rand()%160;}
for(count=1;count<2560;count++)
av[count]=count/8;

byte count3, count2;
for(count2=0, count3=62;count2<63,count3>0;count2++,count3--)
{
setpal(count2,count2,0,0);
delay(0);
setpal(count2+60,63,count2,0);
delay(0);
setpal(count2+120,63,63,count2);
delay(0);
setpal(count2+180,63,63,63);
delay(0);
} 
while(!kbhit())
{
cls(0,vir);
for(count=0;count<700;count++)
{
plot(points[count].x,points[count].y,points[count].col,vir);

if((points[count].y>180)){points[count].x=160;points[count].yvel*=-1;}
if((points[count].y<10)){points[count].y=180;points[count].x=160;}
if((points[count].x>300)){points[count].xvel*=-1;points[count].x=160;points[count].y=180;}
if((points[count].x<20)){points[count].xvel*=-1;points[count].x=160;points[count].y=180;}

if((points[count].y<180))
points[count].yvel+=0.025;

points[count].y+=points[count].yvel;
points[count].x+=points[count].xvel;
}
flip();
}
setmode(TEXT);
printf("EmberEmitter v0.1b, Copyright Blair Watt 1998 \n \n(blair.watt@virgin.net)\n");
free(vir);
__djgpp_nearptr_disable();
return(0);
}

